if(!com.ktsystems.subswitch.PrefixesListSingleton) com.ktsystems.subswitch.PrefixesListSingleton={};
if(!com.ktsystems.subswitch.PrefixItem) com.ktsystems.subswitch.PrefixItem={};

com.ktsystems.subswitch.PrefixesListSingleton = (function() {
    var instance = null;

    function PrefixesList() {
        this.prefixesList = null;
        this.initPrefixesArray = function() {
            com.ktsystems.subswitch.Utils.dumpStr('-> initPrefixesArray');
            var dataString;
            var items = new Array();

            try {
                var dataObj = com.ktsystems.subswitch.Const.subswitch_prefs.getComplexValue("rds", Components.interfaces.nsISupportsString);
                dataString = (dataObj != null ? dataObj.data : null);
                
                if (dataString != "") {
                    if (dataString.indexOf(com.ktsystems.subswitch.Utils.getRDEntrySplitSign()) < 0) {
                        dataString = com.ktsystems.subswitch.Utils.upgradeSettings(dataString);
                    }
                    var itemStrings = dataString.split(com.ktsystems.subswitch.Utils.getRDPrefEntriesSplitSign());
                    
                    for (var i = 0; i < itemStrings.length; i ++) {
                        var itemData = itemStrings[i].split(com.ktsystems.subswitch.Utils.getRDEntrySplitSign());

                        var item = new com.ktsystems.subswitch.PrefixItem(itemData.shift(), itemData.shift());
                        item.aliases = itemData;
                        items.push(item);
                    }
                } 
                this.currentDataString = dataString;
            } catch (e) {
                com.ktsystems.subswitch.Utils.dumpStr(e);
            }

            items.indexOf = function(elt) {
                for (var i = 0; i < this.length; i++) {
                    if (this[i].equals(elt)) {
                        return i;
                    }
                }
                return -1;
            };

            items.removeAll = function() {
                for (var i = this.length - 1; i >= 0; i--) {
                    this.pop();
                }
            };

            com.ktsystems.subswitch.Utils.dumpStr('<- initPrefixesArray; '+items);
            return items;
        };
        this.savePrefixesArray = function (defaultsignature) {
            com.ktsystems.subswitch.Utils.dumpStr('-> savePrefixesArray');
            var writer = {
                sb:       [],
                writeItem:    function (s) {
                    var entry;
                    entry = s.description + com.ktsystems.subswitch.Utils.getRDEntrySplitSign() + s.rd;
                    if (s.aliases && s.aliases.length > 0) {
                         entry += com.ktsystems.subswitch.Utils.getRDEntrySplitSign() + s.aliases.join(com.ktsystems.subswitch.Utils.getRDEntrySplitSign());
                    }
                    this.sb.push(entry);
                },
                toString: function () {  return this.sb.join(com.ktsystems.subswitch.Utils.getRDPrefEntriesSplitSign()); }
            };

            this.prefixesList.forEach(writer.writeItem, writer);
            com.ktsystems.subswitch.Const.subswitch_str.data = writer.toString();

            com.ktsystems.subswitch.Const.subswitch_prefs.setComplexValue("rds", Components.interfaces.nsISupportsString, com.ktsystems.subswitch.Const.subswitch_str);
            if (defaultsignature != undefined) {
                com.ktsystems.subswitch.Const.subswitch_prefs.setCharPref("defaultrd", defaultsignature);
            }

            com.ktsystems.subswitch.Utils.dumpStr('<- savePrefixesArray; '+com.ktsystems.subswitch.Const.subswitch_str.data);
        };
        this.getPrefixesList = function () {
            var dataObj = com.ktsystems.subswitch.Const.subswitch_prefs.getComplexValue("rds", Components.interfaces.nsISupportsString);
            var dataString = (dataObj != null ? dataObj.data : null);
            if (this.currentDataString != dataString) {
                this.prefixesList.removeAll();
                var newList = this.initPrefixesArray();
                newList.forEach(function(s) { com.ktsystems.subswitch.PrefixesListSingleton.getInstance().prefixesList.push(s) });
            }

            return this.prefixesList;
        }
        this.prefixesList = this.initPrefixesArray();
    }

    return new function() {
        this.getInstance = function() {
            if (instance == null) {
                instance = new PrefixesList();
                instance.constructor = null;
            }
            return instance;
        }
    }
})();

com.ktsystems.subswitch.PrefixItem = function(aLabel, aPrefix) {
    this.label = aLabel;
    this.prefix = aPrefix;
    this.aliasesList = [];
}

com.ktsystems.subswitch.PrefixItem.prototype = {
    isValid : function() {
        com.ktsystems.subswitch.Utils.dumpStr("isValid "+this.prefix+" "+this.label);
        return (this.prefix != "" && this.label != "");
    },

    get description() { return this.label;  },
    get rd() {          return this.prefix; },
    get aliases() {     return this.aliasesList; },

    set description(aLabel) { this.label  = aLabel;  },
    set rd(aPrefix) {         this.prefix = aPrefix; },
    set aliases(aAliases)   { this.aliasesList = aAliases; },

    toString : function()   { return ('[' + this.description + com.ktsystems.subswitch.Utils.getRDEntrySplitSign() + this.rd + ']'); },

    equals : function (otherItem) {
        com.ktsystems.subswitch.Utils.dumpStr('-> equals; this:'+this+'; other:'+otherItem);
        if (this.compare(this.rd, otherItem.rd))
            return true;

        for (var i = 0; i < this.aliases.length; i++) {
            if (this.compare(this.aliases[i], otherItem.rd)) {
                return true;
            }
            for (var j = 0; j < otherItem.aliases.length; j++) {
                if (this.compare(this.rd, otherItem.aliases[j])) {
                    return true;
                }
                if (this.compare(this.aliases[i], otherItem.aliases[j])) {
                    return true;
                }
            }
        }

        return false;
    },

    compare : function(sb1, sb2) {
        //com.ktsystems.subswitch.Utils.dumpStr('compare 1 ->' + sb1 + ' ' + sb2);
        //if (sb1 && sb2) {
            var sbi1 = this.removeIgnoredSigns(sb1);
            var sbi2 = this.removeIgnoredSigns(sb2);
            sbi1 = (sbi1 ? sbi1.toLowerCase().trim() : null);
            sbi2 = (sbi2 ? sbi2.toLowerCase().trim() : null);

        //    com.ktsystems.subswitch.Utils.dumpStr('compare 3->' + sbi1 + ' ' + sbi2);

            return (sbi1 == sbi2);
        //} else {
        //    com.ktsystems.subswitch.Utils.dumpStr('compare 2 ->' + sb1 + ' ' + sb2);
        //    return false;
        //}
        
    },

    removeIgnoredSigns : function(sb) {
        if (sb) {
            let ignoreSigns = com.ktsystems.subswitch.Const.subswitch_prefs.getCharPref("discoveryIgnoreSigns");
            for (var i = 0; i < ignoreSigns.length; i++) {
                sb = sb.split(ignoreSigns.charAt(i)).join('');
            }
            sb = sb.split(' ').join('');
        }
        return sb;
    }
}
